summaryrefslogtreecommitdiff
path: root/tests/du/hard-link
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2003-03-08 10:10:09 +0000
committerJim Meyering <jim@meyering.net>2003-03-08 10:10:09 +0000
commit12a14ef03459cf42bf80df007e14eb6aa46efac3 (patch)
tree7550e25269f76a07f19f404f82aadf1b807ab674 /tests/du/hard-link
parent72dc1cec943716f7e2c9dc5132f0cb0c6ae1f315 (diff)
downloadcoreutils-12a14ef03459cf42bf80df007e14eb6aa46efac3.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/du/hard-link')
-rwxr-xr-xtests/du/hard-link41
1 files changed, 41 insertions, 0 deletions
diff --git a/tests/du/hard-link b/tests/du/hard-link
new file mode 100755
index 000000000..7853cde28
--- /dev/null
+++ b/tests/du/hard-link
@@ -0,0 +1,41 @@
+#!/bin/sh
+# Ensure that hard-linked files are counted (and listed) only once.
+# Likewise for excluded directories.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ du --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+mkdir dir dir/sub
+( cd dir && { echo non-empty > f1; ln f1 f2; echo non-empty > sub/F; } )
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+du -a --exclude=sub dir | sed 's/^[0-9][0-9]* //' > out || fail=1
+cat <<\EOF > exp
+dir/f1
+dir
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail